/*
 * ld_gcc_wrapper version 0.1
 * 
 * Copyright (c) 2003 Veli Mankinen (veli.mankinen@movial.fi)
 *
 * ld_gcc_wrapper is licensed under GPL.
 * You can read the full license at http://www.gnu.org/licenses/gpl.txt
 * 
 * */

#define _GNU_SOURCE

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

extern char **environ;

int main(int argc, char **argv)
{
	char *exec_filename;
	char *binary_name = "ld_orig";
	char *tmp;
	char exe[1024];
	int rc;

	if (getenv("SBOX_LD_FAKE_NATIVE")) {
		binary_name = "ld_fake_native";
	}

	rc = readlink("/proc/self/exe", exe, 1024);
	if (rc >= 0) exe[rc] = '\0';
	
	exec_filename = malloc(strlen(exe) + strlen(binary_name) + 2);
	if (exec_filename == NULL) {
		perror("Out of memory");
		exit(1);
	}
	memset(exec_filename, '\0', sizeof(exec_filename));
	
	strcat(exec_filename, exe);
	tmp = strrchr(exec_filename, '/');
	if (tmp != NULL) *(tmp+1) = '\0';
	strcat(exec_filename, binary_name);

	if (execve(exec_filename,argv,environ) < 0) {
		fprintf(stderr, "Error executing program '%s': ", exec_filename);
		perror("");
		exit(1);
	}

	return 2;
}

